/*****************************************************************************
 *
 * INTEL CORPORATION PROPRIETARY INFORMATION
 * This software is supplied under the terms of a license agreement
 * or non-disclosure agreement with Intel Corporation and may not be
 * copied nor disclosed except in accordance with the terms of that
 * agreement.
 * Copyright  2000-2003 Intel Corporation. All Rights Reserved.
 *
 *     $Workfile: afeioctls.h $
 *     $Revision: 1 $
 *     $Modtime: 1/10/05 11:27a $
 *      Author: Oleg Kuporosov
 *
 * ABSTRACT:
 *      Contains the definisions for Windows IOCTL codes.
 *
 *      $History: afeioctls.h $
 * 
 * *****************  Version 1  *****************
 * User: Admin        Date: 1/17/05    Time: 4:57p
 * Created in $/PSTN_Modem/Layer2/linux/ham/serialdrv
 * Stubbed out linux diagnostics ioctl handler
 * By Tawade Prashant request
 * 
 * *****************  Version 34  *****************
 * User: Iivanov      Date: 23.07.04   Time: 15:39
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * Compilation fix:
 * b:\layer1\catawba\afe\windows\control.c(346) : error C2196: case value
 * '2236480' already used
 * b:\layer1\catawba\afe\windows\control.c(347) : error C2196: case value
 * '2236484' already used
 * 
 * *****************  Version 33  *****************
 * User: Admin        Date: 7/21/04    Time: 4:24p
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * DSP<->AFE interface improvement
 * By Igor Ivanov request
 * 
 * *****************  Version 32  *****************
 * User: Okuporos     Date: 25.11.03   Time: 19:41
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * IOC_GET_RING_STATUS was added by Sergey Plotnikov.
 * 
 * *****************  Version 31  *****************
 * User: Okuporos     Date: 4.09.03    Time: 15:28
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * Support of 48 kHz audio redirection was implemented by Alexey Korolev
 * and Konstantin Nevidin.
 * 
 * *****************  Version 30  *****************
 * User: Admin        Date: 7/31/03    Time: 4:23p
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * Prtially fix of SCR 1689 "dynamic mic gain table selection based on
 * audio card name."
 * 
 * By Alexey Korolev request
 * 
 * *****************  Version 29  *****************
 * User: Okuporos     Date: 27.06.03   Time: 15:28
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * IOCTL_SET_MANUAL_CALIBRATION was added.
 * 
 * *****************  Version 28  *****************
 * User: Akorolex     Date: 3.06.03    Time: 16:41
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * AFE_AUDIO_CALLBACK_MIC & AFE_AUDIO_CALLBACK_SPK interfaces are added
 * 
 * *****************  Version 27  *****************
 * User: Akorolex     Date: 8.05.03    Time: 16:38
 * Updated in $/PSTN_Modem/Layer1/Catawba_1_7/include
 * Interfaces names are changed
 * 
 * *****************  Version 26  *****************
 * User: Admin        Date: 2/20/03    Time: 4:26p
 * Updated in $/PSTN_Modem/Layer1/Catawba_1_7/include
 * Device config IO control processing was added
 * By Aleksey Alekseev request
 * 
 * *****************  Version 25  *****************
 * User: Iivanov      Date: 14.02.03   Time: 11:20
 * Updated in $/PSTN_Modem/Layer1/Catawba_1_7/include
 * Line status monitor functionaly was implemented
 * 
 * *****************  Version 24  *****************
 * User: Iivanov      Date: 30.01.03   Time: 18:45
 * Updated in $/PSTN_Modem/Layer1/Catawba_1_7/include
 * AFE migration from PSTN_MODEM_2_2\Catawba to PSTN_MODEM\Catawba_1_7
 * 
 * *****************  Version 25  *****************
 * User: Okuporos     Date: 15.01.03   Time: 13:09
 * Updated in $/PSTN_Modem_2_2/Layer1/Catawba/include
 * (c) was corrected.
 * 
 * *****************  Version 24  *****************
 * User: Akorolex     Date: 25.12.02   Time: 21:51
 * Updated in $/PSTN_Modem_2_2/Layer1/Catawba/include
 * IOCTL GET_TX_DEPTH has been removed
 * No need in it.
 * 
 * *****************  Version 23  *****************
 * User: Iivanov      Date: 23.12.02   Time: 14:53
 * Updated in $/PSTN_Modem_2_2/Layer1/Catawba/include
 * Diagnostic was added
 * 
 * *****************  Version 22  *****************
 * User: Akorolex     Date: 29.11.02   Time: 17:05
 * Updated in $/PSTN_Modem_2_2/Layer1/Catawba/include
 * AFE_GET_LOOP_CURRENT interface implemented
 * 
 * *****************  Version 21  *****************
 * User: Akorolex     Date: 19.11.02   Time: 21:12
 * Updated in $/PSTN_Modem_2_2/Layer1/Catawba/include
 * Changes due to Dynamic Buffering Implementation.
 * New interfaces were added
 * 
 * *****************  Version 18  *****************
 * User: Okuporos     Date: 8.05.02    Time: 22:08
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * AFEIOCTLS_H was restored.
 * 
 * *****************  Version 17  *****************
 * User: Iivanov      Date: 19.04.02   Time: 19:28
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * ioctls for Audio open/close are added
 * 
 * *****************  Version 16  *****************
 * User: Iivanov      Date: 28.03.02   Time: 11:27
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * IOC_GET_FEATURES is replaced with IOC_GET_STATE
 * 
 * *****************  Version 15  *****************
 * User: Iivanov      Date: 21.02.02   Time: 12:25
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 *  AFE_GET_CARDPARAM
 * 
 * *****************  Version 14  *****************
 * User: Okuporos     Date: 7.02.02    Time: 13:39
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * Old IOCTL_GET_TJ_REG was deleted and IOCTL_RESET was added.
 * 
 * *****************  Version 11  *****************
 * User: Akorolex     Date: 26.12.01   Time: 13:29
 * Updated in $/PSTN_Modem/Layer1/Catawba/include
 * IOCTL_AUDIO_ISRENDER     
 * IOCTL_AUDIO_ISCAPTURE        
 * IOCTL_AUDIO_START_RENDER 
 * IOCTL_AUDIO_STOP_RENDER      
 * IOCTL_AUDIO_START_CAPTURE    
 * IOCTL_AUDIO_STOP_CAPTURE 
 * IOCTL_AUDIO_WRITE_STREAM 
 * IOCTL_AUDIO_READ_STREAM      
 * 
 * *****************  Version 4  *****************
 * User: Iivanov      Date: 10.10.01   Time: 16:40
 * Updated in $/Catawba/src/AFE/hardware
 * Making up code
 * 
 * *****************  Version 12  *****************
 * User: Iivanov      Date: 7.06.01    Time: 15:16
 * Updated in $/Catawba/src/AFE/include
 * Caller Id was added
 * 
 * *****************  Version 11  *****************
 * User: Iivanov      Date: 21.05.01   Time: 10:56
 * Updated in $/Catawba/src/AFE/win32/include
 * Power was added
 * 
 * *****************  Version 10  *****************
 * User: Akryukov     Date: 21/03/01   Time: 16:42
 * Updated in $/Catawba/src/AFE/include
 * two  ioctls are replaced by
 * IOCTL_SET_AFE_REG 
 * IOCTL_GET_AFE_REG
 * 
 * *****************  Version 8  *****************
 * User: Okuporos     Date: 9.02.01    Time: 16:27
 * Updated in $/Catawba/src/AFE/include
 * IOCTL_SET/GET_BUFSIZE were deleted.
 * 
 * *****************  Version 6  *****************
 * User: Akryukov     Date: 17/01/01   Time: 12:41
 * Updated in $/Catawba/src/AFE/include
 * IOCTL_SET_OR_GET_TJ_REG control is added
 *****************************************************************************/
#ifndef AFEIOCTLS_H
#define AFEIOCTLS_H

#ifndef __KERNEL__
#include <sys/ioctl.h>
#endif

#ifndef IOCTLCODES_H
    #include "ioctlcodes.h"
#endif

#define IOAB    0x900  /* The IOCTL function codes from 0x800 to 0xFFF are for customer use 
                          codes from 0x800-0x900 are reserved for other ioctls (look at afe\windows\driver.h) */
#define FILE_DEVICE_LINUX_MODEM 0xCC
#define CUSTOM_CTL_CODE(Function) _IOWR(FILE_DEVICE_LINUX_MODEM, Function, void*)


#define IOCTL_ALLOCATE_BUFFERS          CUSTOM_CTL_CODE(IOC_ALLOCATE_BUFFERS )
#define IOCTL_FREE_BUFFERS              CUSTOM_CTL_CODE(IOC_FREE_BUFFERS )
#define IOCTL_GET_TXBUF_ADDR            CUSTOM_CTL_CODE( IOC_GET_TXBUF_ADDR )
#define IOCTL_GET_RXBUF_ADDR            CUSTOM_CTL_CODE( IOC_GET_RXBUF_ADDR )
#define IOCTL_SET_TXBUF_DATA            CUSTOM_CTL_CODE( IOC_SET_TXBUF_DATA )
#define IOCTL_GET_RXBUF_DATA            CUSTOM_CTL_CODE( IOC_GET_RXBUF_DATA )
#define IOCTL_GET_AFE_8BIT_REG          CUSTOM_CTL_CODE( IOC_GET_AFE_8BIT_REG )         
#define IOCTL_SET_AFE_8BIT_REG          CUSTOM_CTL_CODE( IOC_SET_AFE_8BIT_REG )         
#define IOCTL_GET_AFE_32BIT_REG         CUSTOM_CTL_CODE( IOC_GET_AFE_32BIT_REG )         
#define IOCTL_SET_AFE_32BIT_REG         CUSTOM_CTL_CODE( IOC_SET_AFE_32BIT_REG )         
#define IOCTL_GET_AFE_8BIT_MEM          CUSTOM_CTL_CODE( IOC_GET_AFE_8BIT_MEM )         
#define IOCTL_SET_AFE_8BIT_MEM          CUSTOM_CTL_CODE( IOC_SET_AFE_8BIT_MEM )         
#define IOCTL_GET_AFE_32BIT_MEM         CUSTOM_CTL_CODE( IOC_GET_AFE_32BIT_MEM )         
#define IOCTL_SET_AFE_32BIT_MEM         CUSTOM_CTL_CODE( IOC_SET_AFE_32BIT_MEM )         
#define IOCTL_GET_AFE_CONFIG_DATA       CUSTOM_CTL_CODE( IOC_GET_AFE_CONFIG_DATA)
#define IOCTL_SET_AFE_CONFIG_DATA       CUSTOM_CTL_CODE( IOC_SET_AFE_CONFIG_DATA)

#endif /* AFEIOCTLS_H */
